#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

#include "crypt.h"
#define MAXBUFFLEN 3073

int main( int argc, char* argv[] ) {
	int ifh, ofh;
	char buff[MAXBUFFLEN], *ptr;
	char password[50];
	int len;
	if( argc != 4 || strchr( "eEdD", *argv[1] ) == NULL ) {
		printf("Use: cipher d|e|D|E <infile> <outfile>|-\n\t(D|E = weak encryption)\n");
		return (1);
	}
	memset(buff, 0, MAXBUFFLEN-1);
	ifh = open(argv[2], O_RDONLY);
	if( ifh<0 ) {
		printf("unable open input file %s\n", argv[2]);
		return (1);
	}
	len = read(ifh, buff, MAXBUFFLEN-1);
	close(ifh);
	printf("Enter password :");
	fgets(password, 128, stdin);
	password[strlen(password)-1]=0;
	if( *argv[3] == '-' )
		ofh = 1;
    else
		ofh = open(argv[3], O_CREAT|O_RDWR, 0600);
	if( ofh < 0 ) {
		printf("unable to open output file %s\n", argv[3]);
		return (1);
	}
	switch( *argv[1] ) {
	case 'e':
		ptr = encrypt(password, buff, false);
		break;
	case 'd':
   		ptr = decrypt(password, buff, false);
		break;
	case 'E':
		ptr = encrypt(password, buff, true);
		break;
	case 'D':
   		ptr = decrypt(password, buff, true);
		break;
	} 
	if( ptr ) {
		write( ofh, ptr, strlen(ptr) );
		if( ofh != 1 ) close(ofh);
		return (0);
	} else {
		printf("Bad Password or wrong scheme.\n");
		return (1);
	}
}
